package com.alterdekim.hearthhack.component.processor.client.request.generic;

import com.alterdekim.Protocol;
import com.alterdekim.hearthhack.component.TcpConnection;
import com.alterdekim.hearthhack.util.BattleNetPacket;
import lombok.extern.slf4j.Slf4j;

import static com.alterdekim.hearthhack.util.GameUtilities.generateNotification;
import static com.alterdekim.hearthhack.util.GetAccountInfoRequest.PVP_QUEUE;

@Slf4j
public class PlayQueue extends GenericParser {

    @Override
    public void parseGenericRequest(int token, TcpConnection conn) throws Exception {
        Protocol.PlayQueue playQueue = Protocol.PlayQueue.newBuilder()
                .setQueue(Protocol.PlayQueueInfo.newBuilder()
                        .setGameType(Protocol.BnetGameType.BGT_RANKED_STANDARD))
                .build();

        Protocol.Notification n = generateNotification(286, playQueue.toByteString(), playQueue.getSerializedSize());

        Protocol.Header header = Protocol.Header.newBuilder()
                .setServiceId(4)
                .setMethodId(1)
                .setToken(conn.nextToken())
                .setObjectId(0)
                .setSize(n.getSerializedSize())
                .setStatus(0)
                .build();

        conn.send(new BattleNetPacket(header, n.toByteArray()));
    }

    @Override
    public int getId() {
        return PVP_QUEUE.getValue();
    }
}
